<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimSignerEdit = &$Page;
?>
<script>
var currentForm, currentPageID;
var fclaim_signeredit;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "edit";
    fclaim_signeredit = currentForm = new ew.Form("fclaim_signeredit", "edit");

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "claim_signer")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.claim_signer)
        ew.vars.tables.claim_signer = currentTable;
    fclaim_signeredit.addFields([
        ["claim_id", [fields.claim_id.visible && fields.claim_id.required ? ew.Validators.required(fields.claim_id.caption) : null, ew.Validators.integer], fields.claim_id.isInvalid],
        ["signed", [fields.signed.visible && fields.signed.required ? ew.Validators.required(fields.signed.caption) : null], fields.signed.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fclaim_signeredit,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fclaim_signeredit.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
        }

        // Process detail forms
        var dfs = $fobj.find("input[name='detailpage']").get();
        for (var i = 0; i < dfs.length; i++) {
            var df = dfs[i],
                val = df.value,
                frm = ew.forms.get(val);
            if (val && frm && !frm.validate())
                return false;
        }
        return true;
    }

    // Form_CustomValidate
    fclaim_signeredit.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fclaim_signeredit.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fclaim_signeredit.lists.signed = <?= $Page->signed->toClientList($Page) ?>;
    loadjs.done("fclaim_signeredit");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaim_signeredit" id="fclaim_signeredit" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claim_signer">
<input type="hidden" name="action" id="action" value="update">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<?php if ($Page->getCurrentMasterTable() == "claims") { ?>
<input type="hidden" name="<?= Config("TABLE_SHOW_MASTER") ?>" value="claims">
<input type="hidden" name="fk_id" value="<?= HtmlEncode($Page->claim_id->getSessionValue()) ?>">
<?php } ?>
<div class="ew-edit-div"><!-- page* -->
<?php if ($Page->claim_id->Visible) { // claim_id ?>
    <div id="r_claim_id" class="form-group row">
        <label id="elh_claim_signer_claim_id" for="x_claim_id" class="<?= $Page->LeftColumnClass ?>"><?= $Page->claim_id->caption() ?><?= $Page->claim_id->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->claim_id->cellAttributes() ?>>
<?php if ($Page->claim_id->getSessionValue() != "") { ?>
<span id="el_claim_signer_claim_id">
<span<?= $Page->claim_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->claim_id->getDisplayValue($Page->claim_id->ViewValue))) ?>"></span>
</span>
<input type="hidden" id="x_claim_id" name="x_claim_id" value="<?= HtmlEncode($Page->claim_id->CurrentValue) ?>" data-hidden="1">
<?php } else { ?>
<span id="el_claim_signer_claim_id">
<input type="<?= $Page->claim_id->getInputTextType() ?>" data-table="claim_signer" data-field="x_claim_id" name="x_claim_id" id="x_claim_id" size="30" maxlength="11" placeholder="<?= HtmlEncode($Page->claim_id->getPlaceHolder()) ?>" value="<?= $Page->claim_id->EditValue ?>"<?= $Page->claim_id->editAttributes() ?> aria-describedby="x_claim_id_help">
<?= $Page->claim_id->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->claim_id->getErrorMessage() ?></div>
</span>
<?php } ?>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->signed->Visible) { // signed ?>
    <div id="r_signed" class="form-group row">
        <label id="elh_claim_signer_signed" class="<?= $Page->LeftColumnClass ?>"><?= $Page->signed->caption() ?><?= $Page->signed->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->signed->cellAttributes() ?>>
<span id="el_claim_signer_signed">
<template id="tp_x_signed">
    <div class="custom-control custom-radio">
        <input type="radio" class="custom-control-input" data-table="claim_signer" data-field="x_signed" name="x_signed" id="x_signed"<?= $Page->signed->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x_signed" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x_signed"
    name="x_signed"
    value="<?= HtmlEncode($Page->signed->CurrentValue) ?>"
    data-type="select-one"
    data-template="tp_x_signed"
    data-target="dsl_x_signed"
    data-repeatcolumn="5"
    class="form-control<?= $Page->signed->isInvalidClass() ?>"
    data-table="claim_signer"
    data-field="x_signed"
    data-value-separator="<?= $Page->signed->displayValueSeparatorAttribute() ?>"
    <?= $Page->signed->editAttributes() ?>>
<?= $Page->signed->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->signed->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
    <input type="hidden" data-table="claim_signer" data-field="x_id" data-hidden="1" name="x_id" id="x_id" value="<?= HtmlEncode($Page->id->CurrentValue) ?>">
<?php if (!$Page->IsModal) { ?>
<div class="form-group row"><!-- buttons .form-group -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("SaveBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
    </div><!-- /buttons offset -->
</div><!-- /buttons .form-group -->
<?php } ?>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("claim_signer");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
