<?php

namespace PHPMaker2021\educlaims;

// Page object
$Signpage = &$Page;
?>
<?php

$claim_id = filter_input(INPUT_GET,'claim_id',FILTER_VALIDATE_INT);
$token1 = filter_input(INPUT_GET,'token1',FILTER_SANITIZE_SPECIAL_CHARS);
$token2 = filter_input(INPUT_GET,'token2',FILTER_SANITIZE_SPECIAL_CHARS);
$token3 = filter_input(INPUT_GET,'token3',FILTER_SANITIZE_SPECIAL_CHARS);
$uname = CurrentUserName();

if(empty($token1)) {
	echo "<h3>Sign Claim #" . $claim_id . "</h3>";
	$tosign = ExecuteRow("SELECT claims.title AS title, claims.content AS content, v_usr.displayString AS disp FROM claims INNER JOIN v_usr ON claims.subject = v_usr.id  WHERE claims.id =" . $claim_id);
	echo "<p>Claim subject:<b>" . $tosign["disp"] . "</b></p>\n";
	echo "<p>" . $tosign["title"] . "</p>\n";
	echo "<pre style='white-space: pre-wrap'>" . $tosign["content"] . "</pre>\n";

	//TODO check if signer is among signers
	//TODO send both HMAC AND Token
?>
<form action="/application/signpage" method="get">
<br>
<input type="hidden" name="claim_id" value="<?= $claim_id ?>">
Please turn to <b>Page 3</b> in your codebook and enter:<br>
F4 <input size="2" type="text" name="token1"> -
C22 <input size="2" type="text" name="token2"> -
G36 <input size="2" type="text" name="token3">
<br><br>
<input type="submit">
</form>
<?php
} else {
	if($token1 == "398" and $token2 == "348" and $token3 == "880") {
		ExecuteUpdate("REPLACE INTO signature (claim_id,uname) VALUES (". $claim_id . ",'" . $uname . "')");
		echo "<b>Successfully signed</b><br/>\n";

		// both displays and queries
		$ready = display_claim_status($claim_id);

		if (!$ready) {
			echo "<br>Needs more signatures<br/>";
		} else {
			echo "<!--";
			system("/opt/edcgen.sh " . $claim_id);
			echo "-->";
			echo "<br>PDF document generated and signed.";
		}

		echo "<br><a href='/application/yourclaims'>View all claims</a>";
	}
	else {
		echo "Invalid Token";
	}
}

?>

<?= GetDebugMessage() ?>
