<?php

namespace PHPMaker2021\educlaims;

// Page object
$UserattrsAdd = &$Page;
?>
<script>
var currentForm, currentPageID;
var fuserattrsadd;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "add";
    fuserattrsadd = currentForm = new ew.Form("fuserattrsadd", "add");

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "userattrs")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.userattrs)
        ew.vars.tables.userattrs = currentTable;
    fuserattrsadd.addFields([
        ["user_id", [fields.user_id.visible && fields.user_id.required ? ew.Validators.required(fields.user_id.caption) : null, ew.Validators.integer], fields.user_id.isInvalid],
        ["attribute_name", [fields.attribute_name.visible && fields.attribute_name.required ? ew.Validators.required(fields.attribute_name.caption) : null], fields.attribute_name.isInvalid],
        ["attribute_value", [fields.attribute_value.visible && fields.attribute_value.required ? ew.Validators.required(fields.attribute_value.caption) : null], fields.attribute_value.isInvalid],
        ["attribute_flags", [fields.attribute_flags.visible && fields.attribute_flags.required ? ew.Validators.required(fields.attribute_flags.caption) : null], fields.attribute_flags.isInvalid],
        ["last_updated", [fields.last_updated.visible && fields.last_updated.required ? ew.Validators.required(fields.last_updated.caption) : null, ew.Validators.datetime(9)], fields.last_updated.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fuserattrsadd,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fuserattrsadd.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
        }

        // Process detail forms
        var dfs = $fobj.find("input[name='detailpage']").get();
        for (var i = 0; i < dfs.length; i++) {
            var df = dfs[i],
                val = df.value,
                frm = ew.forms.get(val);
            if (val && frm && !frm.validate())
                return false;
        }
        return true;
    }

    // Form_CustomValidate
    fuserattrsadd.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fuserattrsadd.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fuserattrsadd.lists.attribute_flags = <?= $Page->attribute_flags->toClientList($Page) ?>;
    loadjs.done("fuserattrsadd");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fuserattrsadd" id="fuserattrsadd" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="userattrs">
<input type="hidden" name="action" id="action" value="insert">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<div class="ew-add-div"><!-- page* -->
<?php if ($Page->user_id->Visible) { // user_id ?>
    <div id="r_user_id" class="form-group row">
        <label id="elh_userattrs_user_id" for="x_user_id" class="<?= $Page->LeftColumnClass ?>"><?= $Page->user_id->caption() ?><?= $Page->user_id->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->user_id->cellAttributes() ?>>
<?php if (!$Security->isAdmin() && $Security->isLoggedIn() && !$Page->userIDAllow("add")) { // Non system admin ?>
<span id="el_userattrs_user_id">
<span<?= $Page->user_id->viewAttributes() ?>>
<input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->user_id->getDisplayValue($Page->user_id->EditValue))) ?>"></span>
</span>
<input type="hidden" data-table="userattrs" data-field="x_user_id" data-hidden="1" name="x_user_id" id="x_user_id" value="<?= HtmlEncode($Page->user_id->CurrentValue) ?>">
<?php } else { ?>
<span id="el_userattrs_user_id">
<input type="<?= $Page->user_id->getInputTextType() ?>" data-table="userattrs" data-field="x_user_id" name="x_user_id" id="x_user_id" size="30" maxlength="11" placeholder="<?= HtmlEncode($Page->user_id->getPlaceHolder()) ?>" value="<?= $Page->user_id->EditValue ?>"<?= $Page->user_id->editAttributes() ?> aria-describedby="x_user_id_help">
<?= $Page->user_id->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->user_id->getErrorMessage() ?></div>
</span>
<?php } ?>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->attribute_name->Visible) { // attribute_name ?>
    <div id="r_attribute_name" class="form-group row">
        <label id="elh_userattrs_attribute_name" for="x_attribute_name" class="<?= $Page->LeftColumnClass ?>"><?= $Page->attribute_name->caption() ?><?= $Page->attribute_name->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->attribute_name->cellAttributes() ?>>
<span id="el_userattrs_attribute_name">
<input type="<?= $Page->attribute_name->getInputTextType() ?>" data-table="userattrs" data-field="x_attribute_name" name="x_attribute_name" id="x_attribute_name" size="30" maxlength="128" placeholder="<?= HtmlEncode($Page->attribute_name->getPlaceHolder()) ?>" value="<?= $Page->attribute_name->EditValue ?>"<?= $Page->attribute_name->editAttributes() ?> aria-describedby="x_attribute_name_help">
<?= $Page->attribute_name->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->attribute_name->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->attribute_value->Visible) { // attribute_value ?>
    <div id="r_attribute_value" class="form-group row">
        <label id="elh_userattrs_attribute_value" for="x_attribute_value" class="<?= $Page->LeftColumnClass ?>"><?= $Page->attribute_value->caption() ?><?= $Page->attribute_value->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->attribute_value->cellAttributes() ?>>
<span id="el_userattrs_attribute_value">
<textarea data-table="userattrs" data-field="x_attribute_value" name="x_attribute_value" id="x_attribute_value" cols="35" rows="4" placeholder="<?= HtmlEncode($Page->attribute_value->getPlaceHolder()) ?>"<?= $Page->attribute_value->editAttributes() ?> aria-describedby="x_attribute_value_help"><?= $Page->attribute_value->EditValue ?></textarea>
<?= $Page->attribute_value->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->attribute_value->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->attribute_flags->Visible) { // attribute_flags ?>
    <div id="r_attribute_flags" class="form-group row">
        <label id="elh_userattrs_attribute_flags" class="<?= $Page->LeftColumnClass ?>"><?= $Page->attribute_flags->caption() ?><?= $Page->attribute_flags->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->attribute_flags->cellAttributes() ?>>
<span id="el_userattrs_attribute_flags">
<template id="tp_x_attribute_flags">
    <div class="custom-control custom-checkbox">
        <input type="checkbox" class="custom-control-input" data-table="userattrs" data-field="x_attribute_flags" name="x_attribute_flags" id="x_attribute_flags"<?= $Page->attribute_flags->editAttributes() ?>>
        <label class="custom-control-label"></label>
    </div>
</template>
<div id="dsl_x_attribute_flags" class="ew-item-list"></div>
<input type="hidden"
    is="selection-list"
    id="x_attribute_flags[]"
    name="x_attribute_flags[]"
    value="<?= HtmlEncode($Page->attribute_flags->CurrentValue) ?>"
    data-type="select-multiple"
    data-template="tp_x_attribute_flags"
    data-target="dsl_x_attribute_flags"
    data-repeatcolumn="5"
    class="form-control<?= $Page->attribute_flags->isInvalidClass() ?>"
    data-table="userattrs"
    data-field="x_attribute_flags"
    data-value-separator="<?= $Page->attribute_flags->displayValueSeparatorAttribute() ?>"
    <?= $Page->attribute_flags->editAttributes() ?>>
<?= $Page->attribute_flags->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->attribute_flags->getErrorMessage() ?></div>
</span>
</div></div>
    </div>
<?php } ?>
<?php if ($Page->last_updated->Visible) { // last_updated ?>
    <div id="r_last_updated" class="form-group row">
        <label id="elh_userattrs_last_updated" for="x_last_updated" class="<?= $Page->LeftColumnClass ?>"><?= $Page->last_updated->caption() ?><?= $Page->last_updated->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->last_updated->cellAttributes() ?>>
<span id="el_userattrs_last_updated">
<input type="<?= $Page->last_updated->getInputTextType() ?>" data-table="userattrs" data-field="x_last_updated" data-format="9" name="x_last_updated" id="x_last_updated" maxlength="19" placeholder="<?= HtmlEncode($Page->last_updated->getPlaceHolder()) ?>" value="<?= $Page->last_updated->EditValue ?>"<?= $Page->last_updated->editAttributes() ?> aria-describedby="x_last_updated_help">
<?= $Page->last_updated->getCustomMessage() ?>
<div class="invalid-feedback"><?= $Page->last_updated->getErrorMessage() ?></div>
<?php if (!$Page->last_updated->ReadOnly && !$Page->last_updated->Disabled && !isset($Page->last_updated->EditAttrs["readonly"]) && !isset($Page->last_updated->EditAttrs["disabled"])) { ?>
<script>
loadjs.ready(["fuserattrsadd", "datetimepicker"], function() {
    ew.createDateTimePicker("fuserattrsadd", "x_last_updated", {"ignoreReadonly":true,"useCurrent":false,"format":9});
});
</script>
<?php } ?>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
<?php if (!$Page->IsModal) { ?>
<div class="form-group row"><!-- buttons .form-group -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("AddBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
    </div><!-- /buttons offset -->
</div><!-- /buttons .form-group -->
<?php } ?>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("userattrs");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
