<?php

namespace PHPMaker2021\educlaims;

// Page object
$Welcome = &$Page;
?>
<?php

$uid = CurrentUserID();

$uname = CurrentUserName();

$idp = ExecuteScalar("SELECT `attribute_value` FROM `userattrs` WHERE attribute_name='Identity Provider' AND user_id = " . $uid);

// MAJOR TODO
$score['UNI-Tech'] = 90;
$score['Business University'] = 75;
$score['Social Network'] = 35;

$grade['UNI-Tech'] = 'A++';
$grade['Business University'] = 'A';
$grade['Social Network'] = 'C';

$account_desc['UNI-Tech'] = <<<EOT
Your account score is based on the elements of the REFEDS Assurance Framework v1.0 [1]
The base score is 50.
Your home organization is UNI-Tech.
Your home organization uses non-reassignable, unique identifiers: <b>+10</b> (for more info, see [1]: 'ID/eppn-unique-no-reassign')
Your home organization administers all personnel changes within 1 day: <b>+15</b>(for more info, see [1]: '/ATP/ePA-1d')
Your home organization uses strong vetting. <b>+15</b> (for more info, see [1]: 'IAP/high')

[1] https://wiki.refeds.org/display/ASS/REFEDS+Assurance+Framework+ver+1.0
EOT;

$account_desc['Business University'] = <<<EOT
Your account score is based on the elements of the REFEDS Assurance Framework v1.0 [1]
The base score is 50.
Your home organization is Business University.
Your home organization uses non-reassignable, unique identifiers: <b>+10</b> (for more info, see [1]: 'ID/eppn-unique-no-reassign')
Your home organization administers all personnel changes within 30 days: <b>+5</b> (for more info, see [1]: '/ATP/ePA-1m')
Your home organization identity vetting. <b>+10</b> (for more info, see [1]: 'IAP/medium')

[1] https://wiki.refeds.org/display/ASS/REFEDS+Assurance+Framework+ver+1.0
EOT;

$account_desc['Social Network'] = <<<EOT
Your account score is based on the elements of the REFEDS Assurance Framework v1.0 [1]
The base score is 50.
Your home organization is Social Network.
There is no information on whether your identifier is unique or non-reassignable <b>-5</b>
Your attribtes are self-asserted <b>-10</b>

[1] https://wiki.refeds.org/display/ASS/REFEDS+Assurance+Framework+ver+1.0
EOT;

echo "<h3>Account Score: " . $score[$idp] . " grade:<b>" . $grade[$idp] . "</b></h3>\n";
echo "<pre>" . $account_desc[$idp] . "</pre>\n";

?>

<?= GetDebugMessage() ?>
