<?php

namespace PHPMaker2021\educlaims;

// Menu Language
if ($Language && function_exists(PROJECT_NAMESPACE . "Config") && $Language->LanguageFolder == Config("LANGUAGE_FOLDER")) {
    $MenuRelativePath = "";
    $MenuLanguage = &$Language;
} else { // Compat reports
    $LANGUAGE_FOLDER = "../lang/";
    $MenuRelativePath = "../";
    $MenuLanguage = Container("language");
}

// Navbar menu
$topMenu = new Menu("navbar", true, true);
$topMenu->addMenuItem(4, "mi_welcome", $MenuLanguage->MenuPhrase("4", "MenuText"), $MenuRelativePath . "welcome", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}welcome.php'), false, false, "", "", true);
$topMenu->addMenuItem(25, "mci_Make_a_Claim", $MenuLanguage->MenuPhrase("25", "MenuText"), $MenuRelativePath . "claimsadd", -1, "", IsLoggedIn(), false, true, "", "", true);
$topMenu->addMenuItem(14, "mi_tosign", $MenuLanguage->MenuPhrase("14", "MenuText"), $MenuRelativePath . "tosign", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}tosign.php'), false, false, "", "", true);
$topMenu->addMenuItem(26, "mi_yourclaims", $MenuLanguage->MenuPhrase("26", "MenuText"), $MenuRelativePath . "yourclaims", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}yourclaims.php'), false, false, "", "", true);
$topMenu->addMenuItem(5, "mi_userattrs", $MenuLanguage->MenuPhrase("5", "MenuText"), $MenuRelativePath . "userattrslist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}userattrs'), false, false, "", "", true);
$topMenu->addMenuItem(6, "mi_clm_categories", $MenuLanguage->MenuPhrase("6", "MenuText"), $MenuRelativePath . "clmcategorieslist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}clm_categories'), false, false, "", "", true);
$topMenu->addMenuItem(2, "mi_audit", $MenuLanguage->MenuPhrase("2", "MenuText"), $MenuRelativePath . "auditlist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}audit'), false, false, "", "", true);
$topMenu->addMenuItem(3, "mi_user", $MenuLanguage->MenuPhrase("3", "MenuText"), $MenuRelativePath . "userlist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}user'), false, false, "", "", true);
echo $topMenu->toScript();

// Sidebar menu
$sideMenu = new Menu("menu", true, false);
$sideMenu->addMenuItem(4, "mi_welcome", $MenuLanguage->MenuPhrase("4", "MenuText"), $MenuRelativePath . "welcome", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}welcome.php'), false, false, "", "", true);
$sideMenu->addMenuItem(25, "mci_Make_a_Claim", $MenuLanguage->MenuPhrase("25", "MenuText"), $MenuRelativePath . "claimsadd", -1, "", IsLoggedIn(), false, true, "", "", true);
$sideMenu->addMenuItem(14, "mi_tosign", $MenuLanguage->MenuPhrase("14", "MenuText"), $MenuRelativePath . "tosign", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}tosign.php'), false, false, "", "", true);
$sideMenu->addMenuItem(26, "mi_yourclaims", $MenuLanguage->MenuPhrase("26", "MenuText"), $MenuRelativePath . "yourclaims", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}yourclaims.php'), false, false, "", "", true);
$sideMenu->addMenuItem(5, "mi_userattrs", $MenuLanguage->MenuPhrase("5", "MenuText"), $MenuRelativePath . "userattrslist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}userattrs'), false, false, "", "", true);
$sideMenu->addMenuItem(6, "mi_clm_categories", $MenuLanguage->MenuPhrase("6", "MenuText"), $MenuRelativePath . "clmcategorieslist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}clm_categories'), false, false, "", "", true);
$sideMenu->addMenuItem(2, "mi_audit", $MenuLanguage->MenuPhrase("2", "MenuText"), $MenuRelativePath . "auditlist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}audit'), false, false, "", "", true);
$sideMenu->addMenuItem(3, "mi_user", $MenuLanguage->MenuPhrase("3", "MenuText"), $MenuRelativePath . "userlist", -1, "", AllowListMenu('{409145A4-3D7B-4F72-8968-E3E620EDBBEB}user'), false, false, "", "", true);
echo $sideMenu->toScript();
