<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimSignerDelete = &$Page;
?>
<script>
var currentForm, currentPageID;
var fclaim_signerdelete;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "delete";
    fclaim_signerdelete = currentForm = new ew.Form("fclaim_signerdelete", "delete");
    loadjs.done("fclaim_signerdelete");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<script>
if (!ew.vars.tables.claim_signer) ew.vars.tables.claim_signer = <?= JsonEncode(GetClientVar("tables", "claim_signer")) ?>;
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaim_signerdelete" id="fclaim_signerdelete" class="form-inline ew-form ew-delete-form" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claim_signer">
<input type="hidden" name="action" id="action" value="delete">
<?php foreach ($Page->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode(Config("COMPOSITE_KEY_SEPARATOR"), $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?= HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="card ew-card ew-grid">
<div class="<?= ResponsiveTableClass() ?>card-body ew-grid-middle-panel">
<table class="table ew-table">
    <thead>
    <tr class="ew-table-header">
<?php if ($Page->claim_id->Visible) { // claim_id ?>
        <th class="<?= $Page->claim_id->headerCellClass() ?>"><span id="elh_claim_signer_claim_id" class="claim_signer_claim_id"><?= $Page->claim_id->caption() ?></span></th>
<?php } ?>
<?php if ($Page->user_id->Visible) { // user_id ?>
        <th class="<?= $Page->user_id->headerCellClass() ?>"><span id="elh_claim_signer_user_id" class="claim_signer_user_id"><?= $Page->user_id->caption() ?></span></th>
<?php } ?>
<?php if ($Page->signed->Visible) { // signed ?>
        <th class="<?= $Page->signed->headerCellClass() ?>"><span id="elh_claim_signer_signed" class="claim_signer_signed"><?= $Page->signed->caption() ?></span></th>
<?php } ?>
    </tr>
    </thead>
    <tbody>
<?php
$Page->RecordCount = 0;
$i = 0;
while (!$Page->Recordset->EOF) {
    $Page->RecordCount++;
    $Page->RowCount++;

    // Set row properties
    $Page->resetAttributes();
    $Page->RowType = ROWTYPE_VIEW; // View

    // Get the field contents
    $Page->loadRowValues($Page->Recordset);

    // Render row
    $Page->renderRow();
?>
    <tr <?= $Page->rowAttributes() ?>>
<?php if ($Page->claim_id->Visible) { // claim_id ?>
        <td <?= $Page->claim_id->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claim_signer_claim_id" class="claim_signer_claim_id">
<span<?= $Page->claim_id->viewAttributes() ?>>
<?= $Page->claim_id->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->user_id->Visible) { // user_id ?>
        <td <?= $Page->user_id->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claim_signer_user_id" class="claim_signer_user_id">
<span<?= $Page->user_id->viewAttributes() ?>>
<?= $Page->user_id->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->signed->Visible) { // signed ?>
        <td <?= $Page->signed->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claim_signer_signed" class="claim_signer_signed">
<span<?= $Page->signed->viewAttributes() ?>>
<?= $Page->signed->getViewValue() ?></span>
</span>
</td>
<?php } ?>
    </tr>
<?php
    $Page->Recordset->moveNext();
}
$Page->Recordset->close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("DeleteBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
</div>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
