<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimsDelete = &$Page;
?>
<script>
var currentForm, currentPageID;
var fclaimsdelete;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "delete";
    fclaimsdelete = currentForm = new ew.Form("fclaimsdelete", "delete");
    loadjs.done("fclaimsdelete");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<script>
if (!ew.vars.tables.claims) ew.vars.tables.claims = <?= JsonEncode(GetClientVar("tables", "claims")) ?>;
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaimsdelete" id="fclaimsdelete" class="form-inline ew-form ew-delete-form" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claims">
<input type="hidden" name="action" id="action" value="delete">
<?php foreach ($Page->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode(Config("COMPOSITE_KEY_SEPARATOR"), $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?= HtmlEncode($keyvalue) ?>">
<?php } ?>
<div class="card ew-card ew-grid">
<div class="<?= ResponsiveTableClass() ?>card-body ew-grid-middle-panel">
<table class="table ew-table">
    <thead>
    <tr class="ew-table-header">
<?php if ($Page->id->Visible) { // id ?>
        <th class="<?= $Page->id->headerCellClass() ?>"><span id="elh_claims_id" class="claims_id"><?= $Page->id->caption() ?></span></th>
<?php } ?>
<?php if ($Page->subject->Visible) { // subject ?>
        <th class="<?= $Page->subject->headerCellClass() ?>"><span id="elh_claims_subject" class="claims_subject"><?= $Page->subject->caption() ?></span></th>
<?php } ?>
<?php if ($Page->category->Visible) { // category ?>
        <th class="<?= $Page->category->headerCellClass() ?>"><span id="elh_claims_category" class="claims_category"><?= $Page->category->caption() ?></span></th>
<?php } ?>
<?php if ($Page->created_at->Visible) { // created_at ?>
        <th class="<?= $Page->created_at->headerCellClass() ?>"><span id="elh_claims_created_at" class="claims_created_at"><?= $Page->created_at->caption() ?></span></th>
<?php } ?>
<?php if ($Page->signer_status->Visible) { // signer_status ?>
        <th class="<?= $Page->signer_status->headerCellClass() ?>"><span id="elh_claims_signer_status" class="claims_signer_status"><?= $Page->signer_status->caption() ?></span></th>
<?php } ?>
<?php if ($Page->status->Visible) { // status ?>
        <th class="<?= $Page->status->headerCellClass() ?>"><span id="elh_claims_status" class="claims_status"><?= $Page->status->caption() ?></span></th>
<?php } ?>
<?php if ($Page->filename->Visible) { // filename ?>
        <th class="<?= $Page->filename->headerCellClass() ?>"><span id="elh_claims_filename" class="claims_filename"><?= $Page->filename->caption() ?></span></th>
<?php } ?>
    </tr>
    </thead>
    <tbody>
<?php
$Page->RecordCount = 0;
$i = 0;
while (!$Page->Recordset->EOF) {
    $Page->RecordCount++;
    $Page->RowCount++;

    // Set row properties
    $Page->resetAttributes();
    $Page->RowType = ROWTYPE_VIEW; // View

    // Get the field contents
    $Page->loadRowValues($Page->Recordset);

    // Render row
    $Page->renderRow();
?>
    <tr <?= $Page->rowAttributes() ?>>
<?php if ($Page->id->Visible) { // id ?>
        <td <?= $Page->id->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_id" class="claims_id">
<span<?= $Page->id->viewAttributes() ?>>
<?= $Page->id->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->subject->Visible) { // subject ?>
        <td <?= $Page->subject->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_subject" class="claims_subject">
<span<?= $Page->subject->viewAttributes() ?>>
<?= $Page->subject->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->category->Visible) { // category ?>
        <td <?= $Page->category->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_category" class="claims_category">
<span<?= $Page->category->viewAttributes() ?>>
<?= $Page->category->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->created_at->Visible) { // created_at ?>
        <td <?= $Page->created_at->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_created_at" class="claims_created_at">
<span<?= $Page->created_at->viewAttributes() ?>>
<?= $Page->created_at->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->signer_status->Visible) { // signer_status ?>
        <td <?= $Page->signer_status->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_signer_status" class="claims_signer_status">
<span<?= $Page->signer_status->viewAttributes() ?>>
<?= $Page->signer_status->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->status->Visible) { // status ?>
        <td <?= $Page->status->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_status" class="claims_status">
<span<?= $Page->status->viewAttributes() ?>>
<?= $Page->status->getViewValue() ?></span>
</span>
</td>
<?php } ?>
<?php if ($Page->filename->Visible) { // filename ?>
        <td <?= $Page->filename->cellAttributes() ?>>
<span id="el<?= $Page->RowCount ?>_claims_filename" class="claims_filename">
<span<?= $Page->filename->viewAttributes() ?>>
<?php if (!EmptyString($Page->filename->getViewValue()) && $Page->filename->linkAttributes() != "") { ?>
<a<?= $Page->filename->linkAttributes() ?>><?= $Page->filename->getViewValue() ?></a>
<?php } else { ?>
<?= $Page->filename->getViewValue() ?>
<?php } ?>
</span>
</span>
</td>
<?php } ?>
    </tr>
<?php
    $Page->Recordset->moveNext();
}
$Page->Recordset->close();
?>
</tbody>
</table>
</div>
</div>
<div>
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("DeleteBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
</div>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
