<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimsUpdate = &$Page;
?>
<script>
var currentForm, currentPageID;
var fclaimsupdate;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "update";
    fclaimsupdate = currentForm = new ew.Form("fclaimsupdate", "update");

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "claims")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.claims)
        ew.vars.tables.claims = currentTable;
    fclaimsupdate.addFields([
        ["initiator", [fields.initiator.visible && fields.initiator.required ? ew.Validators.required(fields.initiator.caption) : null], fields.initiator.isInvalid],
        ["subject", [fields.subject.visible && fields.subject.required ? ew.Validators.required(fields.subject.caption) : null], fields.subject.isInvalid],
        ["category", [fields.category.visible && fields.category.required ? ew.Validators.required(fields.category.caption) : null], fields.category.isInvalid],
        ["title", [fields.title.visible && fields.title.required ? ew.Validators.required(fields.title.caption) : null], fields.title.isInvalid],
        ["created_at", [fields.created_at.visible && fields.created_at.required ? ew.Validators.required(fields.created_at.caption) : null, ew.Validators.datetime(0), ew.Validators.selected], fields.created_at.isInvalid],
        ["_content", [fields._content.visible && fields._content.required ? ew.Validators.required(fields._content.caption) : null], fields._content.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fclaimsupdate,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fclaimsupdate.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        if (!ew.updateSelected(fobj)) {
            ew.alert(ew.language.phrase("NoFieldSelected"));
            return false;
        }
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
        }
        return true;
    }

    // Form_CustomValidate
    fclaimsupdate.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fclaimsupdate.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fclaimsupdate.lists.subject = <?= $Page->subject->toClientList($Page) ?>;
    fclaimsupdate.lists.category = <?= $Page->category->toClientList($Page) ?>;
    loadjs.done("fclaimsupdate");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaimsupdate" id="fclaimsupdate" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claims">
<?php if ($Page->isConfirm()) { // Confirm page ?>
<input type="hidden" name="action" id="action" value="update">
<input type="hidden" name="confirm" id="confirm" value="confirm">
<?php } else { ?>
<input type="hidden" name="action" id="action" value="confirm">
<?php } ?>
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<?php foreach ($Page->RecKeys as $key) { ?>
<?php $keyvalue = is_array($key) ? implode(Config("COMPOSITE_KEY_SEPARATOR"), $key) : $key; ?>
<input type="hidden" name="key_m[]" value="<?= HtmlEncode($keyvalue) ?>">
<?php } ?>
<div id="tbl_claimsupdate" class="ew-update-div"><!-- page -->
    <?php if (!$Page->isConfirm()) { // Confirm page ?>
    <div class="custom-control custom-checkbox">
        <input type="checkbox" class="custom-control-input" name="u" id="u" onclick="ew.selectAll(this);"<?= $Page->Disabled ?>><label class="custom-control-label" for="u"><?= $Language->phrase("UpdateSelectAll") ?></label>
    </div>
    <?php } ?>
<?php if ($Page->subject->Visible && (!$Page->isConfirm() || $Page->subject->multiUpdateSelected())) { // subject ?>
    <div id="r_subject" class="form-group row">
        <label for="x_subject" class="<?= $Page->LeftColumnClass ?>">
            <?php if (!$Page->isConfirm()) { ?>
            <div class="custom-control custom-checkbox">
                <input type="checkbox" name="u_subject" id="u_subject" class="custom-control-input ew-multi-select" value="1"<?= $Page->subject->multiUpdateSelected() ? " checked" : "" ?>>
                <label class="custom-control-label" for="u_subject"><?= $Page->subject->caption() ?></label>
            </div>
            <?php } else { ?>
            <input type="hidden" name="u_subject" id="u_subject" value="<?= $Page->subject->MultiUpdate ?>">
            <?= $Page->subject->caption() ?>
            <?php } ?>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div <?= $Page->subject->cellAttributes() ?>>
                <?php if (!$Page->isConfirm()) { ?>
                <span id="el_claims_subject">
                    <select
                        id="x_subject"
                        name="x_subject"
                        class="form-control ew-select<?= $Page->subject->isInvalidClass() ?>"
                        data-select2-id="claims_x_subject"
                        data-table="claims"
                        data-field="x_subject"
                        data-value-separator="<?= $Page->subject->displayValueSeparatorAttribute() ?>"
                        data-placeholder="<?= HtmlEncode($Page->subject->getPlaceHolder()) ?>"
                        <?= $Page->subject->editAttributes() ?>>
                        <?= $Page->subject->selectOptionListHtml("x_subject") ?>
                    </select>
                    <?= $Page->subject->getCustomMessage() ?>
                    <div class="invalid-feedback"><?= $Page->subject->getErrorMessage() ?></div>
                <?= $Page->subject->Lookup->getParamTag($Page, "p_x_subject") ?>
                <script>
                loadjs.ready("head", function() {
                    var el = document.querySelector("select[data-select2-id='claims_x_subject']"),
                        options = { name: "x_subject", selectId: "claims_x_subject", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
                    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
                    Object.assign(options, ew.vars.tables.claims.fields.subject.selectOptions);
                    ew.createSelect(options);
                });
                </script>
                </span>
                <?php } else { ?>
                <span id="el_claims_subject">
                <span<?= $Page->subject->viewAttributes() ?>>
                <input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->subject->getDisplayValue($Page->subject->ViewValue))) ?>"></span>
                </span>
                <input type="hidden" data-table="claims" data-field="x_subject" data-hidden="1" name="x_subject" id="x_subject" value="<?= HtmlEncode($Page->subject->FormValue) ?>">
                <?php } ?>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->category->Visible && (!$Page->isConfirm() || $Page->category->multiUpdateSelected())) { // category ?>
    <div id="r_category" class="form-group row">
        <label for="x_category" class="<?= $Page->LeftColumnClass ?>">
            <?php if (!$Page->isConfirm()) { ?>
            <div class="custom-control custom-checkbox">
                <input type="checkbox" name="u_category" id="u_category" class="custom-control-input ew-multi-select" value="1"<?= $Page->category->multiUpdateSelected() ? " checked" : "" ?>>
                <label class="custom-control-label" for="u_category"><?= $Page->category->caption() ?></label>
            </div>
            <?php } else { ?>
            <input type="hidden" name="u_category" id="u_category" value="<?= $Page->category->MultiUpdate ?>">
            <?= $Page->category->caption() ?>
            <?php } ?>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div <?= $Page->category->cellAttributes() ?>>
                <?php if (!$Page->isConfirm()) { ?>
                <span id="el_claims_category">
                    <select
                        id="x_category"
                        name="x_category"
                        class="form-control ew-select<?= $Page->category->isInvalidClass() ?>"
                        data-select2-id="claims_x_category"
                        data-table="claims"
                        data-field="x_category"
                        data-value-separator="<?= $Page->category->displayValueSeparatorAttribute() ?>"
                        data-placeholder="<?= HtmlEncode($Page->category->getPlaceHolder()) ?>"
                        <?= $Page->category->editAttributes() ?>>
                        <?= $Page->category->selectOptionListHtml("x_category") ?>
                    </select>
                    <?= $Page->category->getCustomMessage() ?>
                    <div class="invalid-feedback"><?= $Page->category->getErrorMessage() ?></div>
                <?= $Page->category->Lookup->getParamTag($Page, "p_x_category") ?>
                <script>
                loadjs.ready("head", function() {
                    var el = document.querySelector("select[data-select2-id='claims_x_category']"),
                        options = { name: "x_category", selectId: "claims_x_category", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
                    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
                    Object.assign(options, ew.vars.tables.claims.fields.category.selectOptions);
                    ew.createSelect(options);
                });
                </script>
                </span>
                <?php } else { ?>
                <span id="el_claims_category">
                <span<?= $Page->category->viewAttributes() ?>>
                <input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->category->getDisplayValue($Page->category->ViewValue))) ?>"></span>
                </span>
                <input type="hidden" data-table="claims" data-field="x_category" data-hidden="1" name="x_category" id="x_category" value="<?= HtmlEncode($Page->category->FormValue) ?>">
                <?php } ?>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->title->Visible && (!$Page->isConfirm() || $Page->title->multiUpdateSelected())) { // title ?>
    <div id="r_title" class="form-group row">
        <label for="x_title" class="<?= $Page->LeftColumnClass ?>">
            <?php if (!$Page->isConfirm()) { ?>
            <div class="custom-control custom-checkbox">
                <input type="checkbox" name="u_title" id="u_title" class="custom-control-input ew-multi-select" value="1"<?= $Page->title->multiUpdateSelected() ? " checked" : "" ?>>
                <label class="custom-control-label" for="u_title"><?= $Page->title->caption() ?></label>
            </div>
            <?php } else { ?>
            <input type="hidden" name="u_title" id="u_title" value="<?= $Page->title->MultiUpdate ?>">
            <?= $Page->title->caption() ?>
            <?php } ?>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div <?= $Page->title->cellAttributes() ?>>
                <?php if (!$Page->isConfirm()) { ?>
                <span id="el_claims_title">
                <input type="<?= $Page->title->getInputTextType() ?>" data-table="claims" data-field="x_title" name="x_title" id="x_title" maxlength="512" placeholder="<?= HtmlEncode($Page->title->getPlaceHolder()) ?>" value="<?= $Page->title->EditValue ?>"<?= $Page->title->editAttributes() ?> aria-describedby="x_title_help">
                <?= $Page->title->getCustomMessage() ?>
                <div class="invalid-feedback"><?= $Page->title->getErrorMessage() ?></div>
                </span>
                <?php } else { ?>
                <span id="el_claims_title">
                <span<?= $Page->title->viewAttributes() ?>>
                <input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->title->getDisplayValue($Page->title->ViewValue))) ?>"></span>
                </span>
                <input type="hidden" data-table="claims" data-field="x_title" data-hidden="1" name="x_title" id="x_title" value="<?= HtmlEncode($Page->title->FormValue) ?>">
                <?php } ?>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->created_at->Visible && (!$Page->isConfirm() || $Page->created_at->multiUpdateSelected())) { // created_at ?>
    <div id="r_created_at" class="form-group row">
        <label for="x_created_at" class="<?= $Page->LeftColumnClass ?>">
            <?php if (!$Page->isConfirm()) { ?>
            <div class="custom-control custom-checkbox">
                <input type="checkbox" name="u_created_at" id="u_created_at" class="custom-control-input ew-multi-select" value="1"<?= $Page->created_at->multiUpdateSelected() ? " checked" : "" ?>>
                <label class="custom-control-label" for="u_created_at"><?= $Page->created_at->caption() ?></label>
            </div>
            <?php } else { ?>
            <input type="hidden" name="u_created_at" id="u_created_at" value="<?= $Page->created_at->MultiUpdate ?>">
            <?= $Page->created_at->caption() ?>
            <?php } ?>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div <?= $Page->created_at->cellAttributes() ?>>
                <?php if (!$Page->isConfirm()) { ?>
                <span id="el_claims_created_at">
                <input type="<?= $Page->created_at->getInputTextType() ?>" data-table="claims" data-field="x_created_at" name="x_created_at" id="x_created_at" placeholder="<?= HtmlEncode($Page->created_at->getPlaceHolder()) ?>" value="<?= $Page->created_at->EditValue ?>"<?= $Page->created_at->editAttributes() ?> aria-describedby="x_created_at_help">
                <?= $Page->created_at->getCustomMessage() ?>
                <div class="invalid-feedback"><?= $Page->created_at->getErrorMessage() ?></div>
                <?php if (!$Page->created_at->ReadOnly && !$Page->created_at->Disabled && !isset($Page->created_at->EditAttrs["readonly"]) && !isset($Page->created_at->EditAttrs["disabled"])) { ?>
                <script>
                loadjs.ready(["fclaimsupdate", "datetimepicker"], function() {
                    ew.createDateTimePicker("fclaimsupdate", "x_created_at", {"ignoreReadonly":true,"useCurrent":false,"format":0});
                });
                </script>
                <?php } ?>
                </span>
                <?php } else { ?>
                <span id="el_claims_created_at">
                <span<?= $Page->created_at->viewAttributes() ?>>
                <input type="text" readonly class="form-control-plaintext" value="<?= HtmlEncode(RemoveHtml($Page->created_at->getDisplayValue($Page->created_at->ViewValue))) ?>"></span>
                </span>
                <input type="hidden" data-table="claims" data-field="x_created_at" data-hidden="1" name="x_created_at" id="x_created_at" value="<?= HtmlEncode($Page->created_at->FormValue) ?>">
                <?php } ?>
            </div>
        </div>
    </div>
<?php } ?>
<?php if ($Page->_content->Visible && (!$Page->isConfirm() || $Page->_content->multiUpdateSelected())) { // content ?>
    <div id="r__content" class="form-group row">
        <label for="x__content" class="<?= $Page->LeftColumnClass ?>">
            <?php if (!$Page->isConfirm()) { ?>
            <div class="custom-control custom-checkbox">
                <input type="checkbox" name="u__content" id="u__content" class="custom-control-input ew-multi-select" value="1"<?= $Page->_content->multiUpdateSelected() ? " checked" : "" ?>>
                <label class="custom-control-label" for="u__content"><?= $Page->_content->caption() ?></label>
            </div>
            <?php } else { ?>
            <input type="hidden" name="u__content" id="u__content" value="<?= $Page->_content->MultiUpdate ?>">
            <?= $Page->_content->caption() ?>
            <?php } ?>
        </label>
        <div class="<?= $Page->RightColumnClass ?>">
            <div <?= $Page->_content->cellAttributes() ?>>
                <?php if (!$Page->isConfirm()) { ?>
                <span id="el_claims__content">
                <textarea data-table="claims" data-field="x__content" name="x__content" id="x__content" cols="50" rows="10" placeholder="<?= HtmlEncode($Page->_content->getPlaceHolder()) ?>"<?= $Page->_content->editAttributes() ?> aria-describedby="x__content_help"><?= $Page->_content->EditValue ?></textarea>
                <?= $Page->_content->getCustomMessage() ?>
                <div class="invalid-feedback"><?= $Page->_content->getErrorMessage() ?></div>
                </span>
                <?php } else { ?>
                <span id="el_claims__content">
                <span<?= $Page->_content->viewAttributes() ?>>
                <?= $Page->_content->ViewValue ?></span>
                </span>
                <input type="hidden" data-table="claims" data-field="x__content" data-hidden="1" name="x__content" id="x__content" value="<?= HtmlEncode($Page->_content->FormValue) ?>">
                <?php } ?>
            </div>
        </div>
    </div>
<?php } ?>
</div><!-- /page -->
<?php if (!$Page->IsModal) { ?>
    <div class="form-group row"><!-- buttons .form-group -->
        <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<?php if (!$Page->isConfirm()) { // Confirm page ?>
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit" onclick="this.form.action.value='confirm';"><?= $Language->phrase("UpdateBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
<?php } else { ?>
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("ConfirmBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="submit" onclick="this.form.action.value='cancel';"><?= $Language->phrase("CancelBtn") ?></button>
<?php } ?>
        </div><!-- /buttons offset -->
    </div><!-- /buttons .form-group -->
<?php } ?>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("claims");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
