<?php

namespace PHPMaker2021\educlaims;

// Page object
$ClaimsView = &$Page;
?>
<?php if (!$Page->isExport()) { ?>
<script>
var currentForm, currentPageID;
var fclaimsview;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "view";
    fclaimsview = currentForm = new ew.Form("fclaimsview", "view");
    loadjs.done("fclaimsview");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php } ?>
<script>
if (!ew.vars.tables.claims) ew.vars.tables.claims = <?= JsonEncode(GetClientVar("tables", "claims")) ?>;
</script>
<?php if (!$Page->isExport()) { ?>
<div class="btn-toolbar ew-toolbar">
<?php $Page->ExportOptions->render("body") ?>
<?php $Page->OtherOptions->render("body") ?>
<div class="clearfix"></div>
</div>
<?php } ?>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fclaimsview" id="fclaimsview" class="form-inline ew-form ew-view-form" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="claims">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<table class="table table-striped table-sm ew-view-table">
<?php if ($Page->id->Visible) { // id ?>
    <tr id="r_id">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_id"><?= $Page->id->caption() ?></span></td>
        <td data-name="id" <?= $Page->id->cellAttributes() ?>>
<span id="el_claims_id">
<span<?= $Page->id->viewAttributes() ?>>
<?= $Page->id->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->initiator->Visible) { // initiator ?>
    <tr id="r_initiator">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_initiator"><?= $Page->initiator->caption() ?></span></td>
        <td data-name="initiator" <?= $Page->initiator->cellAttributes() ?>>
<span id="el_claims_initiator">
<span<?= $Page->initiator->viewAttributes() ?>>
<?= $Page->initiator->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->subject->Visible) { // subject ?>
    <tr id="r_subject">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_subject"><?= $Page->subject->caption() ?></span></td>
        <td data-name="subject" <?= $Page->subject->cellAttributes() ?>>
<span id="el_claims_subject">
<span<?= $Page->subject->viewAttributes() ?>>
<?= $Page->subject->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->category->Visible) { // category ?>
    <tr id="r_category">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_category"><?= $Page->category->caption() ?></span></td>
        <td data-name="category" <?= $Page->category->cellAttributes() ?>>
<span id="el_claims_category">
<span<?= $Page->category->viewAttributes() ?>>
<?= $Page->category->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->title->Visible) { // title ?>
    <tr id="r_title">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_title"><?= $Page->title->caption() ?></span></td>
        <td data-name="title" <?= $Page->title->cellAttributes() ?>>
<span id="el_claims_title">
<span<?= $Page->title->viewAttributes() ?>>
<?= $Page->title->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->created_at->Visible) { // created_at ?>
    <tr id="r_created_at">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_created_at"><?= $Page->created_at->caption() ?></span></td>
        <td data-name="created_at" <?= $Page->created_at->cellAttributes() ?>>
<span id="el_claims_created_at">
<span<?= $Page->created_at->viewAttributes() ?>>
<?= $Page->created_at->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->_content->Visible) { // content ?>
    <tr id="r__content">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims__content"><?= $Page->_content->caption() ?></span></td>
        <td data-name="_content" <?= $Page->_content->cellAttributes() ?>>
<span id="el_claims__content">
<span<?= $Page->_content->viewAttributes() ?>>
<?= $Page->_content->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->signers->Visible) { // signers ?>
    <tr id="r_signers">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_signers"><?= $Page->signers->caption() ?></span></td>
        <td data-name="signers" <?= $Page->signers->cellAttributes() ?>>
<span id="el_claims_signers">
<span<?= $Page->signers->viewAttributes() ?>>
<?= $Page->signers->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->signer_status->Visible) { // signer_status ?>
    <tr id="r_signer_status">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_signer_status"><?= $Page->signer_status->caption() ?></span></td>
        <td data-name="signer_status" <?= $Page->signer_status->cellAttributes() ?>>
<span id="el_claims_signer_status">
<span<?= $Page->signer_status->viewAttributes() ?>>
<?= $Page->signer_status->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->status->Visible) { // status ?>
    <tr id="r_status">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_status"><?= $Page->status->caption() ?></span></td>
        <td data-name="status" <?= $Page->status->cellAttributes() ?>>
<span id="el_claims_status">
<span<?= $Page->status->viewAttributes() ?>>
<?= $Page->status->getViewValue() ?></span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->hash->Visible) { // hash ?>
    <tr id="r_hash">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_hash"><?= $Page->hash->caption() ?></span></td>
        <td data-name="hash" <?= $Page->hash->cellAttributes() ?>>
<span id="el_claims_hash">
<span<?= $Page->hash->viewAttributes() ?>>
<?php if (!EmptyString($Page->hash->getViewValue()) && $Page->hash->linkAttributes() != "") { ?>
<a<?= $Page->hash->linkAttributes() ?>><?= $Page->hash->getViewValue() ?></a>
<?php } else { ?>
<?= $Page->hash->getViewValue() ?>
<?php } ?>
</span>
</span>
</td>
    </tr>
<?php } ?>
<?php if ($Page->filename->Visible) { // filename ?>
    <tr id="r_filename">
        <td class="<?= $Page->TableLeftColumnClass ?>"><span id="elh_claims_filename"><?= $Page->filename->caption() ?></span></td>
        <td data-name="filename" <?= $Page->filename->cellAttributes() ?>>
<span id="el_claims_filename">
<span<?= $Page->filename->viewAttributes() ?>>
<?php if (!EmptyString($Page->filename->getViewValue()) && $Page->filename->linkAttributes() != "") { ?>
<a<?= $Page->filename->linkAttributes() ?>><?= $Page->filename->getViewValue() ?></a>
<?php } else { ?>
<?= $Page->filename->getViewValue() ?>
<?php } ?>
</span>
</span>
</td>
    </tr>
<?php } ?>
</table>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<?php if (!$Page->isExport()) { ?>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
<?php } ?>
