<?php

namespace PHPMaker2021\educlaims;

// Page object
$SignerAdd = &$Page;
?>
<script>
var currentForm, currentPageID;
var fsigneradd;
loadjs.ready("head", function () {
    var $ = jQuery;
    // Form object
    currentPageID = ew.PAGE_ID = "add";
    fsigneradd = currentForm = new ew.Form("fsigneradd", "add");

    // Add fields
    var currentTable = <?= JsonEncode(GetClientVar("tables", "signer")) ?>,
        fields = currentTable.fields;
    if (!ew.vars.tables.signer)
        ew.vars.tables.signer = currentTable;
    fsigneradd.addFields([
        ["initiator", [fields.initiator.visible && fields.initiator.required ? ew.Validators.required(fields.initiator.caption) : null], fields.initiator.isInvalid],
        ["signer", [fields.signer.visible && fields.signer.required ? ew.Validators.required(fields.signer.caption) : null], fields.signer.isInvalid]
    ]);

    // Set invalid fields
    $(function() {
        var f = fsigneradd,
            fobj = f.getForm(),
            $fobj = $(fobj),
            $k = $fobj.find("#" + f.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1; // Check rowcnt == 0 => Inline-Add
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            f.setInvalid(rowIndex);
        }
    });

    // Validate form
    fsigneradd.validate = function () {
        if (!this.validateRequired)
            return true; // Ignore validation
        var fobj = this.getForm(),
            $fobj = $(fobj);
        if ($fobj.find("#confirm").val() == "confirm")
            return true;
        var addcnt = 0,
            $k = $fobj.find("#" + this.formKeyCountName), // Get key_count
            rowcnt = ($k[0]) ? parseInt($k.val(), 10) : 1,
            startcnt = (rowcnt == 0) ? 0 : 1, // Check rowcnt == 0 => Inline-Add
            gridinsert = ["insert", "gridinsert"].includes($fobj.find("#action").val()) && $k[0];
        for (var i = startcnt; i <= rowcnt; i++) {
            var rowIndex = ($k[0]) ? String(i) : "";
            $fobj.data("rowindex", rowIndex);

            // Validate fields
            if (!this.validateFields(rowIndex))
                return false;

            // Call Form_CustomValidate event
            if (!this.customValidate(fobj)) {
                this.focus();
                return false;
            }
        }

        // Process detail forms
        var dfs = $fobj.find("input[name='detailpage']").get();
        for (var i = 0; i < dfs.length; i++) {
            var df = dfs[i],
                val = df.value,
                frm = ew.forms.get(val);
            if (val && frm && !frm.validate())
                return false;
        }
        return true;
    }

    // Form_CustomValidate
    fsigneradd.customValidate = function(fobj) { // DO NOT CHANGE THIS LINE!
        // Your custom validation code here, return false if invalid.
        return true;
    }

    // Use JavaScript validation or not
    fsigneradd.validateRequired = <?= Config("CLIENT_VALIDATE") ? "true" : "false" ?>;

    // Dynamic selection lists
    fsigneradd.lists.signer = <?= $Page->signer->toClientList($Page) ?>;
    loadjs.done("fsigneradd");
});
</script>
<script>
loadjs.ready("head", function () {
    // Write your table-specific client script here, no need to add script tags.
});
</script>
<?php $Page->showPageHeader(); ?>
<?php
$Page->showMessage();
?>
<form name="fsigneradd" id="fsigneradd" class="<?= $Page->FormClassName ?>" action="<?= CurrentPageUrl(false) ?>" method="post">
<?php if (Config("CHECK_TOKEN")) { ?>
<input type="hidden" name="<?= $TokenNameKey ?>" value="<?= $TokenName ?>"><!-- CSRF token name -->
<input type="hidden" name="<?= $TokenValueKey ?>" value="<?= $TokenValue ?>"><!-- CSRF token value -->
<?php } ?>
<input type="hidden" name="t" value="signer">
<input type="hidden" name="action" id="action" value="insert">
<input type="hidden" name="modal" value="<?= (int)$Page->IsModal ?>">
<input type="hidden" name="<?= $Page->OldKeyName ?>" value="<?= $Page->OldKey ?>">
<?php if ($Page->getCurrentMasterTable() == "claims") { ?>
<input type="hidden" name="<?= Config("TABLE_SHOW_MASTER") ?>" value="claims">
<input type="hidden" name="fk_id" value="<?= HtmlEncode($Page->claim_id->getSessionValue()) ?>">
<?php } ?>
<div class="ew-add-div"><!-- page* -->
    <span id="el_signer_initiator">
    <input type="hidden" data-table="signer" data-field="x_initiator" data-hidden="1" name="x_initiator" id="x_initiator" value="<?= HtmlEncode($Page->initiator->CurrentValue) ?>">
    </span>
<?php if ($Page->signer->Visible) { // signer ?>
    <div id="r_signer" class="form-group row">
        <label id="elh_signer_signer" for="x_signer" class="<?= $Page->LeftColumnClass ?>"><?= $Page->signer->caption() ?><?= $Page->signer->Required ? $Language->phrase("FieldRequiredIndicator") : "" ?></label>
        <div class="<?= $Page->RightColumnClass ?>"><div <?= $Page->signer->cellAttributes() ?>>
<span id="el_signer_signer">
    <select
        id="x_signer"
        name="x_signer"
        class="form-control ew-select<?= $Page->signer->isInvalidClass() ?>"
        data-select2-id="signer_x_signer"
        data-table="signer"
        data-field="x_signer"
        data-value-separator="<?= $Page->signer->displayValueSeparatorAttribute() ?>"
        data-placeholder="<?= HtmlEncode($Page->signer->getPlaceHolder()) ?>"
        <?= $Page->signer->editAttributes() ?>>
        <?= $Page->signer->selectOptionListHtml("x_signer") ?>
    </select>
    <?= $Page->signer->getCustomMessage() ?>
    <div class="invalid-feedback"><?= $Page->signer->getErrorMessage() ?></div>
<?= $Page->signer->Lookup->getParamTag($Page, "p_x_signer") ?>
<script>
loadjs.ready("head", function() {
    var el = document.querySelector("select[data-select2-id='signer_x_signer']"),
        options = { name: "x_signer", selectId: "signer_x_signer", language: ew.LANGUAGE_ID, dir: ew.IS_RTL ? "rtl" : "ltr" };
    options.dropdownParent = $(el).closest("#ew-modal-dialog, #ew-add-opt-dialog")[0];
    Object.assign(options, ew.vars.tables.signer.fields.signer.selectOptions);
    ew.createSelect(options);
});
</script>
</span>
</div></div>
    </div>
<?php } ?>
</div><!-- /page* -->
    <?php if (strval($Page->claim_id->getSessionValue()) != "") { ?>
    <input type="hidden" name="x_claim_id" id="x_claim_id" value="<?= HtmlEncode(strval($Page->claim_id->getSessionValue())) ?>">
    <?php } ?>
<?php if (!$Page->IsModal) { ?>
<div class="form-group row"><!-- buttons .form-group -->
    <div class="<?= $Page->OffsetColumnClass ?>"><!-- buttons offset -->
<button class="btn btn-primary ew-btn" name="btn-action" id="btn-action" type="submit"><?= $Language->phrase("AddBtn") ?></button>
<button class="btn btn-default ew-btn" name="btn-cancel" id="btn-cancel" type="button" data-href="<?= HtmlEncode(GetUrl($Page->getReturnUrl())) ?>"><?= $Language->phrase("CancelBtn") ?></button>
    </div><!-- /buttons offset -->
</div><!-- /buttons .form-group -->
<?php } ?>
</form>
<?php
$Page->showPageFooter();
echo GetDebugMessage();
?>
<script>
// Field event handlers
loadjs.ready("head", function() {
    ew.addEventHandlers("signer");
});
</script>
<script>
loadjs.ready("load", function () {
    // Write your table-specific startup script here, no need to add script tags.
});
</script>
