<?php

namespace PHPMaker2021\educlaims;

// Page object
$Yourclaims = &$Page;
?>
<?php

echo "<h3> Claims to Sign </h3>";

$tosign = get_tosign();

if (empty($tosign)) {
	echo "<p>Nothing to sign at this time.</p>";
}

else {
	echo "<ul>";
	foreach ($tosign as $claim) {
		echo "<li>" . $claim["title"] . "<br><b>Subject</b>: " . $claim["disp"] . "<br>" . $claim["created"]. " "
		. '<a href="/claims/' . $claim["file"] . '">' . $claim["file"]  . "</a></li>\n"; 
	}
	echo "</ul>";
}


echo "<h3> Claims About You </h3>";

$tosign = get_aboutyou();

if (empty($tosign)) {
	echo "<p>No claims yet.</p>";
}

else {
	echo "<ul>";
	foreach ($tosign as $claim) {
		echo "<li>" . $claim["title"] . "<br>" . $claim["created"]. " "
		. '<a href="/claims/' . $claim["file"] . '">' . $claim["file"]  . "</a></li>\n"; 
	}
	echo "</ul>";
}

echo "<h3> Claims Signed By You </h3>";

$tosign = get_signed();

if (empty($tosign)) {
	echo "<p>Nothing was signed by you yet.</p>";
}

else {
	echo "<ul>";
	foreach ($tosign as $claim) {
		echo "<li>" . $claim["title"] . "<br><b>Subject</b>: " . $claim["disp"] . "<br>" . $claim["created"]. " "
		. '<a href="/claims/' . $claim["file"] . '">' . $claim["file"]  . "</a></li>\n"; 
	}
	echo "</ul>";
}


?>

<?= GetDebugMessage() ?>
